"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var index_exports = {};
__export(index_exports, {
  default: () => InitCodeHighlight
});
module.exports = __toCommonJS(index_exports);

// src/styles/theme-default.ts
var BACKGROUND_COLOR = "#fff";
var LINE_HEIGHT = "20px";
var FONT_SIZE = "13px";
var defaultCssTheme = `
.init-code-highlight {
  background: ${BACKGROUND_COLOR};
  color: #4f559c;
}

.init-code-highlight .token.punctuation {
  color: #4a4a4a;
}

.init-code-highlight .token.keyword {
  color: #8500ff;
}

.init-code-highlight .token.operator {
  color: #ff5598;
}

.init-code-highlight .token.string {
  color: #41ad8f;
}

.init-code-highlight .token.comment {
  color: #9badb7;
}

.init-code-highlight .token.function {
  color: #8500ff;
}

.init-code-highlight .token.boolean {
  color: #8500ff;
}

.init-code-highlight .token.number {
  color: #8500ff;
}

.init-code-highlight .token.selector {
  color: #8500ff;
}

.init-code-highlight .token.property {
  color: #8500ff;
}

.init-code-highlight .token.tag {
  color: #8500ff;
}

.init-code-highlight .token.attr-value {
  color: #8500ff;
}
`;

// src/utils/css-supports.ts
function cssSupports(property, value) {
  if (typeof CSS !== "undefined") {
    return CSS.supports(property, value);
  }
  if (typeof document === "undefined") {
    return false;
  }
  return toCamelCase(property) in document.body.style;
}
function toCamelCase(cssProperty) {
  cssProperty = cssProperty.split("-").filter((word) => !!word).map((word) => word[0].toUpperCase() + word.substr(1)).join("");
  return cssProperty[0].toLowerCase() + cssProperty.substr(1);
}

// src/styles/editor.ts
var FONT_FAMILY = `"SFMono-Regular", Consolas, "Liberation Mono", Menlo, Courier, monospace`;
var COLOR = cssSupports("caret-color", "#000") ? BACKGROUND_COLOR : "#ccc";
var LINE_NUMBER_WIDTH = "40px";
var editorCss = `
  .init-code-highlight {
    width: 100%;
    height: 100%;
    overflow: hidden;
    border : 1px solid #EAEEFB;
    border-radius: 4px;
    position: relative;
  }

  .init-code-highlight, .init-code-highlight * {
    box-sizing: border-box;
  }

  .init-code-highlight__pre {
    pointer-events: none;
    z-index: 3;
    overflow: hidden;
  }

  .init-code-highlight__textarea {
    background: none;
    border: none;
    color: ${COLOR};
    z-index: 1;
    resize: none;
    font-family: ${FONT_FAMILY};
    -webkit-appearance: pre;
    caret-color: #111;
    z-index: 2;
    width: 100%;
    height: 100%;
  }

  .init-code-highlight--has-line-numbers .init-code-highlight__textarea {
    width: calc(100% - ${LINE_NUMBER_WIDTH});
  }

  .init-code-highlight__code {
    display: block;
    font-family: ${FONT_FAMILY};
    overflow: hidden;
  }

  .init-code-highlight__flatten {
    padding: 10px;
    font-size: ${FONT_SIZE};
    line-height: ${LINE_HEIGHT};
    white-space: pre;
    position: absolute;
    top: 0;
    left: 0;
    overflow: auto;
    margin: 0 !important;
    outline: none;
    text-align: left;
  }

  .init-code-highlight--has-line-numbers .init-code-highlight__flatten {
    width: calc(100% - ${LINE_NUMBER_WIDTH});
    left: ${LINE_NUMBER_WIDTH};
  }

  .init-code-highlight__line-highlight {
    position: absolute;
    top: 10px;
    left: 0;
    width: 100%;
    height: ${LINE_HEIGHT};
    background: rgba(0,0,0,0.1);
    z-index: 1;
  }

  .init-code-highlight__lines {
    padding: 10px 4px;
    font-size: 12px;
    line-height: ${LINE_HEIGHT};
    font-family: 'Cousine', monospace;
    position: absolute;
    left: 0;
    top: 0;
    width: ${LINE_NUMBER_WIDTH};
    height: 100%;
    text-align: right;
    color: #999;
    z-index: 2;
  }

  .init-code-highlight__lines__line {
    display: block;
  }

  .init-code-highlight.init-code-highlight--has-line-numbers {
    padding-left: ${LINE_NUMBER_WIDTH};
  }

  .init-code-highlight.init-code-highlight--has-line-numbers:before {
    content: '';
    position: absolute;
    left: 0;
    top: 0;
    width: ${LINE_NUMBER_WIDTH};
    height: 100%;
    // background: #eee;
    background: #dcdfe6;
    z-index: 1;
  }

  .init-code-highlight__copyButton{
    position: absolute;
    right: 5px;
    top: 5px;
    z-index: 3;
    background: #EAEEFB;
    border: none;
    color: #999;
    cursor: pointer;
    outline: none;
    width: 22px;
    height: 22px;
    border-radius: 4px;
  }

  .init-code-highlight__copyMessage{
    position: absolute;
    right: 32px;
    top: 5px;
    z-index: 3;
    background: #EAEEFB;
    border: none;
    color: #999;
    cursor: pointer;
    outline: none;
    width: 55px;
    height: 22px;
    line-height: 22px;
    border-radius: 4px;
    font-size: 12px;
    text-align: center;
    font-family: 'Cousine', monospace;
  }

`;

// src/styles/injector.ts
function injectCss(css, styleName = "init-code-highlight-style", parent = document.head) {
  const CSS_ID = styleName;
  const PARENT = parent;
  if (!css) {
    return false;
  }
  if (document.getElementById(CSS_ID)) {
    return true;
  }
  const style = document.createElement("style");
  style.innerHTML = css;
  style.id = CSS_ID;
  PARENT.appendChild(style);
  return true;
}

// src/utils/html-escape.ts
var entityMap = {
  "&": "&amp;",
  "<": "&lt;",
  ">": "&gt;",
  '"': "&quot;",
  "'": "&#39;",
  "/": "&#x2F;",
  "`": "&#x60;",
  "=": "&#x3D;"
};
function escapeHtml(string) {
  return String(string).replace(/[&<>"'`=/]/g, (s) => entityMap[s]);
}

// src/index.ts
var import_prismjs = __toESM(require("prismjs"), 1);
var import_prism_autoloader = require("prismjs/plugins/autoloader/prism-autoloader");
var InitCodeHighlight = class {
  editorRoot;
  opts;
  events;
  code = "";
  elWrapper;
  elTextarea;
  elPre;
  elCode;
  elLineNumbers;
  elCopyButton;
  elCopyButtonMessage;
  lineNumber = 0;
  constructor(selectorOrElement, opts) {
    if (!selectorOrElement) {
      throw new Error(
        "InitCodeHighlight expects a parameter which is Element or a String selector"
      );
    }
    if (!opts) {
      throw new Error(
        "InitCodeHighlight expects an object containing options as second parameter"
      );
    }
    import_prismjs.default.plugins.autoloader.languages_path = opts.languagesUrl || "https://cdnjs.cloudflare.com/ajax/libs/prism/1.29.0/components/";
    if (selectorOrElement instanceof HTMLElement) {
      this.editorRoot = selectorOrElement;
    } else {
      const editorRoot = document.querySelector(selectorOrElement);
      if (editorRoot) {
        this.editorRoot = editorRoot;
      }
    }
    this.opts = opts;
    this.events = {
      _input() {
      },
      _keydown() {
      },
      _scroll() {
      }
    };
    this.startEditor();
  }
  startEditor() {
    const isCSSInjected = injectCss(
      editorCss,
      void 0,
      this.opts.styleParent
    );
    if (!isCSSInjected) {
      throw new Error("Failed to inject init-code-highlight CSS.");
    }
    this.createWrapper();
    this.createTextarea();
    this.createPre();
    this.createCode();
    this.runOptions();
    this.listenTextarea();
    this.populateDefault();
    this.updateCode(this.code);
  }
  createWrapper() {
    this.code = this.editorRoot.innerHTML;
    this.editorRoot.innerHTML = "";
    this.elWrapper = this.createElement("div", this.editorRoot);
    this.elWrapper.classList.add("init-code-highlight");
  }
  createTextarea() {
    this.elTextarea = this.createElement(
      "textarea",
      this.elWrapper
    );
    this.elTextarea.classList.add(
      "init-code-highlight__textarea",
      "init-code-highlight__flatten"
    );
  }
  createPre() {
    this.elPre = this.createElement("pre", this.elWrapper);
    this.elPre.classList.add(
      "init-code-highlight__pre",
      "init-code-highlight__flatten",
      `language-${this.opts.language || "plain"}`
    );
  }
  createCode() {
    this.elCode = this.createElement("code", this.elPre);
    this.elCode.classList.add(
      "init-code-highlight__code",
      `language-${this.opts.language || "html"}`
    );
  }
  createLineNumbers() {
    this.elLineNumbers = this.createElement("div", this.elWrapper);
    this.elLineNumbers.classList.add("init-code-highlight__lines");
    this.elWrapper.classList.add("init-code-highlight--has-line-numbers");
    this.setLineNumber();
  }
  createCopyButton() {
    this.elCopyButtonMessage = this.createElement("div", this.elWrapper);
    this.elCopyButtonMessage.classList.add("init-code-highlight__copyMessage");
    this.elCopyButtonMessage.innerHTML = "Copied!";
    this.elCopyButtonMessage.style.display = "none";
    this.elCopyButton = this.createElement("div", this.elWrapper);
    this.elCopyButton.classList.add("init-code-highlight__copyButton");
    this.elCopyButton.innerHTML = '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 256 256"><rect width="256" height="256" fill="none"/><polygon points="88 40 88 88 168 88 168 168 216 168 216 40 88 40" opacity="0.2"/><polyline points="168 168 216 168 216 40 88 40 88 88" fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="16"/><rect x="40" y="88" width="128" height="128" fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="16"/></svg>';
    this.elCopyButton.addEventListener("click", () => {
      navigator.clipboard.writeText(this.code).then(() => {
        this.elCopyButtonMessage.style.display = "block";
        setTimeout(() => {
          this.elCopyButtonMessage.style.display = "none";
        }, 1e3);
      });
    });
  }
  destroyLineNumbers() {
    this.elWrapper.classList.remove("init-code-highlight--has-line-numbers");
    if (this.elLineNumbers) {
      this.elLineNumbers.remove();
    }
  }
  createElement(elementTag, whereToAppend) {
    const element = document.createElement(elementTag);
    whereToAppend.appendChild(element);
    return element;
  }
  runOptions() {
    this.opts.rtl = this.opts.rtl || false;
    this.opts.tabSize = this.opts.tabSize || 2;
    this.opts.enableAutocorrect = this.opts.enableAutocorrect || false;
    this.opts.lineNumbers = this.opts.lineNumbers || false;
    this.opts.defaultTheme = this.opts.defaultTheme !== false;
    this.opts.areaId = this.opts.areaId || null;
    this.opts.ariaLabelledby = this.opts.ariaLabelledby || null;
    this.opts.readonly = this.opts.readonly || false;
    this.opts.copyButton = this.opts.copyButton || false;
    this.opts.maxLines = this.opts.maxLines || 100;
    this.opts.minLines = this.opts.minLines || 1;
    if (typeof this.opts.handleTabs !== "boolean") {
      this.opts.handleTabs = true;
    }
    if (typeof this.opts.handleSelfClosingCharacters !== "boolean") {
      this.opts.handleSelfClosingCharacters = true;
    }
    if (typeof this.opts.handleNewLineIndentation !== "boolean") {
      this.opts.handleNewLineIndentation = true;
    }
    if (this.opts.rtl === true) {
      this.elTextarea.setAttribute("dir", "rtl");
      this.elPre.setAttribute("dir", "rtl");
    }
    if (this.opts.enableAutocorrect === false) {
      this.elTextarea.setAttribute("spellcheck", "false");
      this.elTextarea.setAttribute("autocapitalize", "off");
      this.elTextarea.setAttribute("autocomplete", "off");
      this.elTextarea.setAttribute("autocorrect", "off");
    }
    if (this.opts.lineNumbers) {
      this.createLineNumbers();
    }
    if (this.opts.defaultTheme) {
      injectCss(defaultCssTheme, "theme-default", this.opts.styleParent);
    }
    if (this.opts.areaId) {
      this.elTextarea.setAttribute("id", this.opts.areaId);
    }
    if (this.opts.ariaLabelledby) {
      this.elTextarea.setAttribute("aria-labelledby", this.opts.ariaLabelledby);
    }
    if (this.opts.readonly) {
      this.enableReadonlyMode();
    }
    if (this.opts.copyButton) {
      this.createCopyButton();
    }
    if (this.opts.lineNumbers) {
      this.updateLineNumbersCount();
    }
  }
  updateLineNumbersCount() {
    let numberList = "";
    for (let i = 1; i <= this.lineNumber; i++) {
      numberList = numberList + `<span class="init-code-highlight__lines__line">${i}</span>`;
    }
    this.elLineNumbers.innerHTML = numberList;
  }
  updateEditorHeight() {
    let maxLineNumber = this.opts.maxLines || 100;
    let minLineNumber = this.opts.minLines || 3;
    let limitedLineNumber = this.lineNumber;
    if (limitedLineNumber > maxLineNumber) {
      limitedLineNumber = maxLineNumber;
    } else if (limitedLineNumber < minLineNumber) {
      limitedLineNumber = minLineNumber;
    }
    this.elWrapper.style.height = `${limitedLineNumber * 20 + 24}px`;
  }
  listenTextarea() {
    this.events._input = (e) => {
      if (this.opts.readonly) {
        return;
      }
      const target = e.target;
      this.code = target.value;
      this.elCode.innerHTML = escapeHtml(target.value);
      this.highlight();
      setTimeout(() => {
        this.runUpdate();
        this.setLineNumber();
      }, 1);
    };
    this.elTextarea.addEventListener("input", this.events._input);
    this.elTextarea.addEventListener(
      "keydown",
      this.events._keydown = (e) => {
        if (this.opts.readonly) {
          return;
        }
        this.handleTabs(e);
        this.handleSelfClosingCharacters(e);
        this.handleNewLineIndentation(e);
      }
    );
    this.elTextarea.addEventListener(
      "scroll",
      this.events._scroll = (e) => {
        const target = e.target;
        this.elPre.style.transform = `translate3d(-${target.scrollLeft}px, -${target.scrollTop}px, 0)`;
      }
    );
  }
  handleTabs(e) {
    if (this.opts.handleTabs) {
      if (e.code !== "Tab") {
        return;
      }
      e.preventDefault();
      const input = this.elTextarea;
      const selectionDir = input.selectionDirection;
      const selStartPos = input.selectionStart;
      const selEndPos = input.selectionEnd;
      const inputVal = input.value;
      let beforeSelection = inputVal.substring(0, selStartPos);
      let selectionVal = inputVal.substring(selStartPos, selEndPos);
      const afterSelection = inputVal.substring(selEndPos);
      const indent = " ".repeat(this.opts.tabSize || 2);
      if (selStartPos !== selEndPos && selectionVal.length >= indent.length) {
        const currentLineStart = selStartPos - (beforeSelection.split("\n").pop()?.length || 0);
        let startIndentLen = indent.length;
        let endIndentLen = indent.length;
        if (e.shiftKey) {
          const currentLineStartStr = inputVal.substring(
            currentLineStart,
            currentLineStart + indent.length
          );
          if (currentLineStartStr === indent) {
            startIndentLen = -startIndentLen;
            if (currentLineStart > selStartPos) {
              selectionVal = selectionVal.substring(0, currentLineStart) + selectionVal.substring(currentLineStart + indent.length);
              endIndentLen = 0;
            } else if (currentLineStart === selStartPos) {
              startIndentLen = 0;
              endIndentLen = 0;
              selectionVal = selectionVal.substring(indent.length);
            } else {
              endIndentLen = -endIndentLen;
              beforeSelection = beforeSelection.substring(0, currentLineStart) + beforeSelection.substring(currentLineStart + indent.length);
            }
          } else {
            startIndentLen = 0;
            endIndentLen = 0;
          }
          selectionVal = selectionVal.replace(
            new RegExp("\n" + indent.split("").join("\\"), "g"),
            "\n"
          );
        } else {
          beforeSelection = beforeSelection.substring(0, currentLineStart) + indent + beforeSelection.substring(currentLineStart, selStartPos);
          selectionVal = selectionVal.replace(/\n/g, "\n" + indent);
        }
        input.value = beforeSelection + selectionVal + afterSelection;
        input.selectionStart = selStartPos + startIndentLen;
        input.selectionEnd = selStartPos + selectionVal.length + endIndentLen;
        input.selectionDirection = selectionDir;
      } else {
        input.value = beforeSelection + indent + afterSelection;
        input.selectionStart = selStartPos + indent.length;
        input.selectionEnd = selStartPos + indent.length;
      }
      const newCode = input.value;
      this.updateCode(newCode);
      input.selectionEnd = selEndPos + (this.opts?.tabSize || 2);
    }
  }
  handleSelfClosingCharacters(e) {
    if (!this.opts.handleSelfClosingCharacters) return;
    const openChars = ["(", "[", "{", "<", "'", '"'];
    const closeChars = [")", "]", "}", ">", "'", '"'];
    const key = e.key;
    if (!openChars.includes(key) && !closeChars.includes(key)) {
      return;
    }
    this.closeCharacter(key);
  }
  setLineNumber() {
    this.lineNumber = this.code.split("\n").length;
    if (this.opts.lineNumbers) {
      this.updateLineNumbersCount();
    }
    this.updateEditorHeight();
  }
  handleNewLineIndentation(e) {
    if (!this.opts.handleNewLineIndentation) return;
    if (e.code !== "Enter") {
      return;
    }
    e.preventDefault();
    const input = this.elTextarea;
    const selStartPos = input.selectionStart;
    const selEndPos = input.selectionEnd;
    const inputVal = input.value;
    const beforeSelection = inputVal.substring(0, selStartPos);
    const afterSelection = inputVal.substring(selEndPos);
    const lineStart = inputVal.lastIndexOf("\n", selStartPos - 1);
    const spaceLast = lineStart + inputVal.slice(lineStart + 1).search(/[^ ]|$/);
    const indent = spaceLast > lineStart ? spaceLast - lineStart : 0;
    const newCode = beforeSelection + "\n" + " ".repeat(indent) + afterSelection;
    input.value = newCode;
    input.selectionStart = selStartPos + indent + 1;
    input.selectionEnd = selStartPos + indent + 1;
    this.updateCode(input.value);
    this.updateEditorHeight();
  }
  closeCharacter(char) {
    const input = this.elTextarea;
    const selectionStart = input.selectionStart;
    const selectionEnd = input.selectionEnd;
    if (!this.skipCloseChar(char)) {
      let closeChar = char;
      switch (char) {
        case "(":
          closeChar = String.fromCharCode(char.charCodeAt(0) + 1);
          break;
        case "<":
        case "{":
        case "[":
          closeChar = String.fromCharCode(char.charCodeAt(0) + 2);
          break;
      }
      const selectionText = this.code.substring(selectionStart, selectionEnd);
      const newCode = `${this.code.substring(
        0,
        selectionStart
      )}${selectionText}${closeChar}${this.code.substring(selectionEnd)}`;
      this.updateCode(newCode);
    } else {
      const skipChar = this.code.substring(selectionEnd, selectionEnd + 1) === char;
      const newSelectionEnd = skipChar ? selectionEnd + 1 : selectionEnd;
      const closeChar = !skipChar && ["'", '"'].includes(char) ? char : "";
      const newCode = `${this.code.substring(
        0,
        selectionStart
      )}${closeChar}${this.code.substring(newSelectionEnd)}`;
      this.updateCode(newCode);
      input.selectionEnd = ++input.selectionStart;
    }
    input.selectionEnd = selectionStart;
  }
  skipCloseChar(char) {
    const input = this.elTextarea;
    const selectionStart = input.selectionStart;
    const selectionEnd = input.selectionEnd;
    const hasSelection = Math.abs(selectionEnd - selectionStart) > 0;
    return [")", "}", "]", ">"].includes(char) || ["'", '"'].includes(char) && !hasSelection;
  }
  updateCode(newCode) {
    this.code = newCode;
    this.elTextarea.value = newCode;
    this.elCode.innerHTML = escapeHtml(newCode);
    this.highlight();
    this.setLineNumber();
    setTimeout(this.runUpdate.bind(this), 1);
  }
  updateLanguage(newLanguage) {
    this.opts.language = newLanguage;
    this.elCode.classList.forEach((className) => {
      if (className.startsWith("language-")) {
        this.elCode.classList.remove(className);
      }
    });
    this.elCode.classList.add(`language-${newLanguage}`);
    this.highlight();
  }
  getPrism() {
    return import_prismjs.default;
  }
  populateDefault() {
    this.updateCode(this.code);
  }
  highlight() {
    import_prismjs.default.highlightElement(this.elCode, false);
  }
  updateCallBack = null;
  onUpdate(callback) {
    if (callback && {}.toString.call(callback) !== "[object Function]") {
      throw Error("CodeHighlight expects callback of type Function");
    }
    this.updateCallBack = callback;
  }
  getCode() {
    return this.code;
  }
  runUpdate() {
    if (this.updateCallBack) {
      this.updateCallBack(this.code);
    }
  }
  enableReadonlyMode() {
    this.elTextarea.setAttribute("readonly", "true");
    this.opts.readonly = true;
  }
  disableReadonlyMode() {
    this.elTextarea.removeAttribute("readonly");
    this.opts.readonly = false;
  }
  toggleReadonlyMode() {
    if (!this.opts.readonly) {
      this.enableReadonlyMode();
    } else {
      this.disableReadonlyMode();
    }
  }
  enableLineNumbers() {
    this.opts.lineNumbers = true;
    this.destroyLineNumbers();
    this.createLineNumbers();
    this.updateLineNumbersCount();
  }
  disableLineNumbers() {
    if (this.opts.lineNumbers) {
      this.destroyLineNumbers();
    }
    this.opts.lineNumbers = false;
  }
  toggleLineNumbers() {
    if (!this.opts.lineNumbers) {
      this.enableLineNumbers();
    } else {
      this.disableLineNumbers();
    }
  }
  dispose() {
    this.elTextarea.removeEventListener("input", this.events._input);
    this.elTextarea.removeEventListener("keydown", this.events._keydown);
    this.elTextarea.removeEventListener("scroll", this.events._scroll);
    this.elWrapper.remove();
  }
};
//# sourceMappingURL=index.cjs.map